#include <cstdio>
#include <cstring>
#include <vector>
#include <map>
using namespace std;

const int maxN = 50;
const int maxK = 50;
const int N0 = 25;

map<int,int> num[maxN+1];
int cnt;

void add(int mask,int i)
{
	if(!num[i][mask]++) cnt++;
}

void del(int mask,int i)
{
	if(!--num[i][mask]) --cnt;
}

vector<int> q[maxN+1][maxN*(maxN+1)/2+1];

int suf[maxN];

void rec(int i)
{
	if(cnt>maxK) return;
	q[i][cnt].push_back(suf[0]);
	if(i==N0) return;
	for(int j=0;j<i;j++)
		suf[j]*=2;
	for(int d=0;d<2;d++)
	{
		for(int j=0;j<=i;j++)
		{
			suf[j]^=d;
			add(suf[j],i-j+1);
		}
		rec(i+1);
		for(int j=0;j<=i;j++)
		{
			del(suf[j],i-j+1);
			suf[j]^=d;
		}
	}
	for(int j=0;j<i;j++)
		suf[j]/=2;
}

int n,k;
char s[maxN+1],w[maxN+1];

int main()
{
	rec(0);
	int T;
	scanf("%d\n",&T);
	for(int t=0;t<T;t++)
	{
		scanf("%d %d\n",&n,&k);
		gets(s);
		int ans=0;
		if(n<=N0)
		{
			int mask=0,patt=0;
			for(int i=0;i<n;i++)
			{
				patt*=2;
				mask*=2;
				if(s[i]!='?')
				{
					patt++;
					mask += s[i]=='7';
				}
			}
			for(int j=0;j<=k && j<=n*(n+1)/2;j++)
				for(int i=0;i<q[n][j].size();i++)
					if((q[n][j][i] & patt) == mask) ans++;
		} else {
			if(k>=n)
			{
				int n4=0,n7=0;
				for(int i=0;i<n;i++)
				{
					n4 += s[i]=='4';
					n7 += s[i]=='7';
				}
				ans += (n4==0) + (n7==0);
			}
		}
		printf("%d\n",ans);
	}
	return 0;
}
